summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorEli Schwartz <eschwartz@archlinux.org>2020-08-05 10:02:10 -0400
committerAllan McRae <allan@archlinux.org>2020-08-10 09:57:37 +1000
commit2403fc97325908043917732b32adf87a2eaff603 (patch)
tree9b2db64964df53f5ea94ce4707f8ec5b9faac1af
parent74aacf44958e1343b910b3fbdcf753393857f070 (diff)
downloadpacman-2403fc97325908043917732b32adf87a2eaff603.tar.gz
pacman-2403fc97325908043917732b32adf87a2eaff603.zip
repo-add: use more libmakepkg to handle common compression routines
Currently the list of supported formats for an archive, is maintained in two places. And repo-add does not actually get updated. :( In the process, remove some of the logical duplication when calling bsdtar/compress_as. Signed-off-by: Eli Schwartz <eschwartz@archlinux.org> Signed-off-by: Allan McRae <allan@archlinux.org>
-rw-r--r--scripts/repo-add.sh.in32
1 files changed, 12 insertions, 20 deletions
diff --git a/scripts/repo-add.sh.in b/scripts/repo-add.sh.in
index 160fd93a..7182d1b8 100644
--- a/scripts/repo-add.sh.in
+++ b/scripts/repo-add.sh.in
@@ -44,6 +44,7 @@ USE_COLOR='y'
PREVENT_DOWNGRADE=0
# Import libmakepkg
+source "$LIBRARY"/util/compress.sh
source "$LIBRARY"/util/message.sh
# ensure we have a sane umask set
@@ -189,21 +190,13 @@ verify_signature() {
}
verify_repo_extension() {
- local repofile=$1
-
- case $repofile in
- *.db.tar.gz) TAR_OPT="-z" ;;
- *.db.tar.bz2) TAR_OPT="-j" ;;
- *.db.tar.xz) TAR_OPT="-J" ;;
- *.db.tar.zst) TAR_OPT="--zstd" ;;
- *.db.tar.Z) TAR_OPT="-Z" ;;
- *.db.tar) TAR_OPT="" ;;
- *) error "$(gettext "'%s' does not have a valid database archive extension.")" \
- "$repofile"
- exit 1 ;;
- esac
+ local junk=()
+ if [[ $1 = *.db.tar* ]] && get_compression_command "$1" junk; then
+ return 0
+ fi
- printf '%s' "$TAR_OPT"
+ error "$(gettext "'%s' does not have a valid database archive extension.")" "$1"
+ exit 1
}
# write an entry to the pacman database
@@ -522,7 +515,6 @@ rotate_db() {
}
create_db() {
- TAR_OPT=$(verify_repo_extension "$REPO_DB_FILE")
# $LOCKFILE is already guaranteed to be absolute so this is safe
dirname=${LOCKFILE%/*}
@@ -532,13 +524,13 @@ create_db() {
tempname=$dirname/.tmp.$filename
pushd "$tmpdir/$repo" >/dev/null
- if ( shopt -s nullglob; files=(*); (( ${#files[*]} )) ); then
- bsdtar -c ${TAR_OPT} -f "$tempname" *
- else
+ local files=(*)
+ if [[ ${files[*]} = '*' ]]; then
# we have no packages remaining? zip up some emptyness
warning "$(gettext "No packages remain, creating empty database.")"
- bsdtar -c ${TAR_OPT} -f "$tempname" -T /dev/null
+ files=(-T /dev/null)
fi
+ bsdtar -cf - "${files[@]}" | compress_as "$filename" > "$tempname"
popd >/dev/null
create_signature "$tempname"
@@ -656,7 +648,7 @@ else
LOCKFILE=$PWD/$REPO_DB_FILE.lck
fi
-verify_repo_extension "$REPO_DB_FILE" >/dev/null
+verify_repo_extension "$REPO_DB_FILE"
REPO_DB_PREFIX=${REPO_DB_FILE##*/}
REPO_DB_PREFIX=${REPO_DB_PREFIX%.db.*}